from flask import Flask
from portal.config import CONFIGURATIONS
from flask_sqlalchemy import SQLAlchemy
import os
from storage.core.storage import Storage
from portal.rest.courses.courses import courses
from portal.rest.users.users import users
from portal.rest.roles.roles import roles
from portal.rest.groups.groups import groups

db = SQLAlchemy()
app = Flask('portal')
# TODO - urgent
storage = Storage({
    "submissions_dir": "todo",
    "test_files_dir": "todo",
    "workspace_dir": "todo"
})


def config_app(flask_app):
    """Configures the Flask app based on production stage."""
    config_type = os.environ.get('PORTAL_CONFIG_TYPE', 'devel')
    config_object = CONFIGURATIONS[config_type]
    if config_object is None:
        raise EnvironmentError()  # TODO some custom ex
    flask_app.config.from_object(config_object)
    # app.logger.removeHandler(default_handler) # from Flask release 1.0, not yet available


def create_app():
    # app configuration
    config_app(app)
    app.register_blueprint(courses)
    app.register_blueprint(users)
    app.register_blueprint(roles)
    app.register_blueprint(groups)
    # database bind to app
    db.init_app(app)

    return app


import portal.database.models

